#ifndef EXECUTOR_H_
#define EXECUTOR_H_

#include <string>
#include <map>

#include "antlr4-runtime.h"
#include "ExprLabeledBaseVisitor.h"

using namespace std;

typedef antlrcpp::Any Object;

class Executor : public ExprLabeledBaseVisitor
{
private:
    map<string, Object> symtab;

public:
    Executor() {}
    virtual ~Executor() {}

    Object visitAssign(ExprLabeledParser::AssignContext *ctx);
    Object visitPrint(ExprLabeledParser::PrintContext *ctx);
    Object visitInt(ExprLabeledParser::IntContext *ctx);
    Object visitId(ExprLabeledParser::IdContext *ctx);
    Object visitMulDiv(ExprLabeledParser::MulDivContext *ctx);
    Object visitAddSub(ExprLabeledParser::AddSubContext *ctx);
    Object visitParens(ExprLabeledParser::ParensContext *ctx);
};

#endif /* EXECUTOR_H_ */
